//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                            ForEx Canada    http://4-X.CA         |
//|                    Copyright  2010, 4-X.CA ALL RIGHTS RESERVED! |
//|             TrendTrader_v1.06.011.mq4    2010-05-28  at   10:00  |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#include <stdlib.mqh>
#include <stderror.mqh>
#include <CurrencyPairs.mqh>
#include <NewBar.mqh>  // Go Trading ONLY at the Start of a New Bar!

#define SIGNAL_NONE      0
#define SIGNAL_BUY       1
#define SIGNAL_SELL      2
#define SIGNAL_CLOSEBUY  3
#define SIGNAL_CLOSESELL 4

extern bool   bUseTakeProfit      =  True;
extern int    iTakeProfit         =   500;
extern bool   bUseStopLoss        =  True;
extern int    iStopLoss           =    70;
extern bool   bUseRetractment     =  True;
extern int    iRetractmentMax     =    35;
extern bool   bUseTrailingStop    =  True;
extern int    iTrailingStop       =     0;
extern int    iTradeIntervalOpen  =     0;
extern int    iTradeIntervalClose =     0;
extern int    iTradeOpenMinPips   =     3;
extern double dLots               =  0.01;
extern double dRiskMax            =  0.03; //= 3% Utilizs Full Account Figures for Margin Calculations
extern int    iSlippage           =     2;
extern int    iSpreadMax          =     6;
extern int    iOrders             =     0;
extern int    i_iMA_Interval      =     2;
extern int    i_iMA_Shift         =    -1;
extern int    i_iMA_Method        =     2;  // 2=Smoothed Moving Average Calculation Method Used
extern int    i_iMA_Applied_Price =     5; // 5=Typical==(HLC/3)Point on Bar where Price is Measured at.
extern int    iTimeTradeDivider   =     1;
extern int    iMagicNumber        =  123456789;
extern string sTradeComment       = "TrendTrader_v1.06.011";
extern bool   bSpreadAddedIn      = False;
extern bool   bEachTickMode       = False;
extern bool   bSignalMail         = False;

double adTradeOrders[1];
int  iBarCount;
int  iCurrent;
bool IsTrade = False;
bool bTickCheck = False;
static datetime LastTradeBarTime;
extern double dFullMargin = 1; // Use All Account Figures to Calculate Margin


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                 Experts Initialization Function                  |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int init()
 {
double  FullMargin = AccountFreeMarginMode();
  LastTradeBarTime = Time[1]; // Initialise the Time[] Variable Array

   iBarCount = Bars;

   if (bEachTickMode) iCurrent = 0; else iCurrent = 1;

   return(0);
 }


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|               Experts DeInitialization Function                  |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
int deinit()
 {
   return(0);
 }

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                     Experts Start Function                       |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RefreshRates();
int start()
{
   int Order = SIGNAL_NONE;
   int iOrders, Ticket;
   double StopLossLevel, TakeProfitLevel;

   if (bEachTickMode && Bars != iBarCount) bTickCheck = False;
   iOrders = OrdersTotal();
   Order  = SIGNAL_NONE;



  // isNewBar : Do <any tick> code here such as trailing stops etc
   {
   if (LastTradeBarTime == Time[0]) return(0); // Not <first detected tick> on this bar so quit
   else LastTradeBarTime = Time[0]; // and continue
   }
// Do <once per bar> trading stuff here
//   if(isNewBar()
     adTradeOrders[0] = OrdersTotal();
         Print("adTradeOrders = ",adTradeOrders,".  OrdersTotal() = ",OrdersTotal());
      iOrders = ArraySize(adTradeOrders);
      iOrders = ArraySort(adTradeOrders, WHOLE_ARRAY, 0, MODE_ASCEND);
         Print("iOrders = ",iOrders);
      {
      for (int i = 0; i < iOrders; i ++)
         {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
            {
//         if(isNewBar());
         if(isNewBar()) IsTrade = True;
         if(OrderType() == OP_BUY && OrderSymbol() == Symbol())
            if(iRetractmentMax * Point > MathAbs(OrderTicket() - Ask)) Order = SIGNAL_CLOSEBUY; //=3; //=
               Print("OrderType() = ",OrderType());
               Print("iRetractmentMax * Point = ",(iRetractmentMax * Point);
               Print(("MathAbs(OrderTicket() - Ask)) = ",(MathAbs(OrderTicket() - Ask));
             OrderClose(OrderTicket(), OrderLots(), Ask, iSlippage, LimeGreen);
            }
            if(OrderType() == OP_SELL && (iRetractmentMax * Point) > (MathAbs(OrderTicket() - Bid))) Order = SIGNAL_CLOSESELL; // = 4; //
               OrderClose(OrderTicket(), OrderLots(), Bid, iSlippage, Magenta);
         }
       return;
      }


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                 Variables Definitions Begins                     |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

RefreshRates();
int iSpread = MarketInfo(Symbol(),MODE_SPREAD);

double Var1  = iMagicNumber;
string Var2  = sTradeComment;
double Var3  = iTradeIntervalOpen;
double Var4  = iTradeIntervalClose;
double Var6  = iTradeOpenMinPips * Point;
double Var7  = iSpread;
double Var8  = iSpreadMax;
double Var9  = i_iMA_Interval;
double Var10 = i_iMA_Shift;
double Var11 = dRiskMax;
double Var12 = iTimeTradeDivider;
double Var13 = bSpreadAddedIn;
double Var14 = iMA(NULL, iTradeIntervalOpen, i_iMA_Interval, -1, i_iMA_Method, i_iMA_Applied_Price, iCurrent + 1);
double Var15 = iMA(NULL, iTradeIntervalOpen, i_iMA_Interval, -1, i_iMA_Method, i_iMA_Applied_Price, iCurrent + 2);
double Var16 = (iRetractmentMax * Point);


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|     Start of Factors to Close Orders over Retractment Limit      |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RefreshRates();
  {
  double Retractment1_1  = iOpen(NULL,0,0);
  double Retractment1_2  = iOpen(NULL,0,1);
  double Retractment1_3  = (iRetractmentMax * Point);
  }
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|      End of Factors to Close Orders over Retractment Limit       |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|            Factors for Opening new Long Buy Orders               |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

RefreshRates();
   {
   double Buy1_1  = iOpen (NULL, iTradeIntervalOpen, iCurrent + 1);
   double Buy1_2  = iMA   (NULL, iTradeIntervalOpen, i_iMA_Interval, i_iMA_Shift, i_iMA_Method, i_iMA_Applied_Price, iCurrent + 1);
   double Buy2_1  = iMA   (NULL, iTradeIntervalOpen, i_iMA_Interval, i_iMA_Shift, i_iMA_Method, i_iMA_Applied_Price, iCurrent + 1);
   double Buy2_2  = iClose(NULL, iTradeIntervalOpen, iCurrent + 1);
   double Buy3_1  = iOpen (NULL, iTradeIntervalOpen, iCurrent + 1);
   double Buy3_2  = iClose(NULL, iTradeIntervalOpen, iCurrent + 1);
   double Buy4_1  = iOpen (NULL, iTradeIntervalOpen, iCurrent + 1);
   double Buy4_2  = iOpen (NULL, iTradeIntervalOpen, iCurrent + 0);
   double Buy5_1  =  Var14  +  Var6;
   double Buy5_2  = iOpen (NULL, iTradeIntervalOpen, iCurrent + 0);
   double Buy6_1  =  Var7;
   double Buy6_2  =  Var8;
   }

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|           Factors for Opening new Short Sell Orders              |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

RefreshRates();
   {
   double Sell1_1  = iOpen (NULL, iTradeIntervalOpen, iCurrent + 1);
   double Sell1_2  = iMA   (NULL, iTradeIntervalOpen, i_iMA_Interval, i_iMA_Shift, i_iMA_Method, i_iMA_Applied_Price, iCurrent + 1);
   double Sell2_1  = iMA   (NULL, iTradeIntervalOpen, i_iMA_Interval, i_iMA_Shift, i_iMA_Method, i_iMA_Applied_Price, iCurrent + 1);
   double Sell2_2  = iClose(NULL, iTradeIntervalOpen, iCurrent);
   double Sell3_1  = iMA   (NULL, iTradeIntervalOpen, i_iMA_Interval, i_iMA_Shift, i_iMA_Method, i_iMA_Applied_Price, iCurrent + 1);
   double Sell3_2  = iClose(NULL, iTradeIntervalOpen, iCurrent + 1);
   double Sell4_1  = iOpen (NULL, iTradeIntervalOpen, iCurrent + 1);
   double Sell4_2  = iOpen (NULL, iTradeIntervalOpen, iCurrent);
   double Sell5_1  = Var14  -  Var6 ;
   double Sell5_2  = iOpen(NULL, iTradeIntervalOpen, iCurrent);
   double Sell6_1  = Var8 ;
   double Sell6_2  = Var7 ;
   }

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                 Start of Factors to Close Orders                 |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

RefreshRates();
  {
  double Close1_1  = iMA  (NULL, iTradeIntervalClose, i_iMA_Interval, i_iMA_Shift, i_iMA_Method, i_iMA_Applied_Price, iCurrent + 1);
  double Close1_2  = iOpen(NULL,0,iCurrent);
  }
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|                  End of Factors to Close Orders                  |
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   //Check positions
RefreshRates();

if isNewBar();
 {
     adTradeOrders[0] = OrdersTotal();
     // Print("adTradeOrders = ",adTradeOrders,".  OrdersTotal() = ",OrdersTotal());

   iOrders = ArraySort(adTradeOrders, WHOLE_ARRAY, 0, MODE_ASCEND);
    //  Print("iOrders = ",iOrders);

   bool IsTrade = False;

   for (int j = 0; j < iOrders; j ++)
   {
      OrderSelect(j, SELECT_BY_POS, MODE_TRADES);

       if(OrderType() != OP_SELL )
      {
         if(isNewBar()) IsTrade = True;
         if(OrderType() == OP_BUY && OrderSymbol() == Symbol())
         {

            //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            //|            Start of Signals to Exit Long Buy Orders              |
            //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

         if (Close1_1 - (iRetractmentMax * Point) > Close1_2) Order = SIGNAL_CLOSEBUY; //StopLoss

            //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
            //|              End of Signals to Exit Long Buy Orders              |
            //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

             iOrders = ArraySize(adTradeOrders);
             iOrders = ArraySort(adTradeOrders, WHOLE_ARRAY, 0, MODE_ASCEND);

            if (Order == SIGNAL_CLOSEBUY && bEachTickMode && !bTickCheck || !bEachTickMode && Bars != iBarCount)
            {
               OrderClose(OrderTicket(), OrderLots(), Bid, iSlippage, Magenta);
          //     if (bSignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Close Buy");
               if (!bEachTickMode) iBarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
        /*
            if(bUseTrailingStop && iTrailingStop > 0)
            {                 
               if(Bid - OrderOpenPrice() > Point * iTrailingStop)
               {
                  if(OrderStopLoss() < Bid - Point * iTrailingStop)
                  {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - (Point * iTrailingStop), OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!bEachTickMode) iBarCount = Bars;
                     continue;
                  }
               }
            }
          
         }
         else
         {
    */
        //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        //|            Start of Signals to Exit Short Sell Orders            |
        //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      if(Close1_1 + (iRetractmentMax * Point) > Close1_2) Order = SIGNAL_CLOSESELL;  // StopLoss
      if(isNewBar() && iRetractmentMax > 0 && Close1_1 + (iRetractmentMax * Point) < Close1_2) Order = SIGNAL_CLOSESELL;

        //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        //|            End of Signals to Exit Short Sell Orders              |
        //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

            
           if(isNewBar() && Order == SIGNAL_CLOSESELL && bEachTickMode && !bTickCheck || !bEachTickMode && Bars != iBarCount)
            {
               OrderClose(OrderTicket(), OrderLots(), Ask, iSlippage, DarkOrange);
//               if (bSignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Close Sell");
  //             if (!bEachTickMode) iBarCount = Bars;
               IsTrade = False;
               continue;
            }
            //Trailing stop
   /*
   //         if(bUseTrailingStop && iTrailingStop > 0)
            {                 
     //          if((OrderOpenPrice() - Ask) > (Point * iTrailingStop))
       //        {
         //         if((OrderStopLoss() > (Ask + Point * iTrailingStop)) || (OrderStopLoss() == 0))
           /       {
  //                   OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * iTrailingStop, OrderTakeProfit(), 0, DarkOrange);
    //                 if (!bEachTickMode) iBarCount = Bars;
      //               continue;
        //          }
          //     }
     //       }
   */
         }
      }
   }
 }
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


{
  // isNewBar : Do <any tick> code here such as trailing stops etc
   {
   if (LastTradeBarTime == Time[0]) return(0); // Not <first detected tick> on this bar so quit
   else LastTradeBarTime = Time[0]; // and continue
   }

// Do <once per bar> trading stuff here
   if(isNewBar()
     adTradeOrders[0] = OrdersTotal();
       Print("adTradeOrders = ",adTradeOrders,".  OrdersTotal() = ",OrdersTotal());
      iOrders = ArraySize(adTradeOrders) ;
      iOrders = ArraySort(adTradeOrders, WHOLE_ARRAY, 0, MODE_ASCEND);
        Print("iOrders = ",iOrders);
//     {
      for (int k = 0; k < iOrders; k ++)
         {
         OrderSelect(k, SELECT_BY_POS, MODE_TRADES);
            {
         if(isNewBar());
         if(isNewBar()) IsTrade = True;
         if(OrderType() == OP_BUY && OrderSymbol() == Symbol())
            if((iRetractmentMax * Point) > (MathAbs(Open[OrderTicket()] - Ask))) Order = SIGNAL_CLOSEBUY; //=3; //=
               Print("OrderType() = ",OrderType());
               Print("iRetractmentMax * Point = ",(iRetractmentMax * Point));
               Print("MathAbs(OrderTicket() - Ask) = ",(MathAbs(Open[OrderTicket()] - Ask)));
             OrderClose(OrderTicket(), OrderLots(), Ask, iSlippage, LimeGreen);
            }
            if(OrderType() == OP_SELL && (iRetractmentMax * Point) > (MathAbs(OrderTicket() - Bid))) Order = SIGNAL_CLOSESELL; // = 4; //
               OrderClose(OrderTicket(), OrderLots(), Bid, iSlippage, Magenta);
         }
       return;
      }


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   //|              Start of Conditions to OpenNew Orders               |
   //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     if (Buy1_1 < Buy1_2 && Buy2_1 < Buy2_2 && Buy3_1 < Buy3_2 && Buy4_1 < Buy4_2 && Buy5_1 < Buy5_2 && Buy6_1 <= Buy6_2) Order = SIGNAL_BUY;
     if (Sell1_1 > Sell1_2 && Sell2_1 > Sell2_2 && Sell3_1 > Sell3_2 && Sell4_1 > Sell4_2 && Sell5_1 > Sell5_2 && Sell6_1 >= Sell6_2) Order = SIGNAL_SELL;

   //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   //|               End of Conditions to OpenNew Orders                |
   //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   //------- Open New Buy Orders ---------------------------------

   if (Order == SIGNAL_BUY && ((bEachTickMode && !bTickCheck) || (!bEachTickMode && (Bars != iBarCount))))
   {
      if(!IsTrade)
      {
         //Check free margin
         if (AccountFreeMargin() < (1000 * dLots))
         {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (bUseStopLoss)   StopLossLevel   = (Ask - (iStopLoss   * Point)); else StopLossLevel   = 0.0;
         if (bUseTakeProfit) TakeProfitLevel = (Ask + (iTakeProfit * Point)); else TakeProfitLevel = 0.0;

      if (AccountFreeMarginCheck(Symbol(),OP_BUY,dLots) >= dRiskMax)

         Ticket = OrderSend(Symbol(), OP_BUY, dLots, Ask, iSlippage, StopLossLevel, TakeProfitLevel, "Buy(#" + iMagicNumber + ")", iMagicNumber, 0, DodgerBlue);
         if(Ticket > 0)
         {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES))
            {
				Print("BUY order opened : ", OrderOpenPrice());
                if (bSignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
			}
			else
			{
				Print("Error opening BUY order : ", GetLastError());
			}
         }
         if (bEachTickMode) bTickCheck = True;
         if (!bEachTickMode) iBarCount = Bars;
         return(0);
      }
   }


   //------- Open New Sell Orders ---------------------------------
   
   if (Order == SIGNAL_SELL && ((bEachTickMode && !bTickCheck) || (!bEachTickMode && (Bars != iBarCount))))
   {
      if(!IsTrade)
      {
         //Check free margin
         if (AccountFreeMargin() < (1000 * dLots))
         {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         if (bUseStopLoss) StopLossLevel = (Bid + (iStopLoss * Point)); else StopLossLevel = 0.0;
         if (bUseTakeProfit) TakeProfitLevel = (Bid - (iTakeProfit * Point)); else TakeProfitLevel = 0.0;

      if (AccountFreeMarginCheck(Symbol(),OP_SELL,dLots) >= dRiskMax)

         Ticket = OrderSend(Symbol(), OP_SELL, dLots, Bid, iSlippage, StopLossLevel, TakeProfitLevel, "Sell(#" + iMagicNumber + ")", iMagicNumber, 0, DeepPink);
         if(Ticket > 0)
         {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES))
            {
				Print("SELL order opened : ", OrderOpenPrice());
                if (bSignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
			}
			else
			{
				Print("Error opening SELL order : ", GetLastError());
			}
         }
         if (bEachTickMode) bTickCheck = True;
         if (!bEachTickMode) iBarCount = Bars;
         return(0);
      }
   }

   if (!bEachTickMode) iBarCount = Bars;

   return(0);

}


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//|  Start of Close Orders with excessive Retractmenters at each new bar  |            |
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

/*

void CloseOrdersInRetractment()
   {
   if (LastTradeBarTime == Time[0]) return(0); // Not <first detected tick> on this bar so quit
   else LastTradeBarTime = Time[0]; // and continue

      {
// Do <once per bar> trading stuff here
         iOrders = ArraySize(adTradeOrders);
         iOrders = ArraySort(adTradeOrders, WHOLE_ARRAY, 0, MODE_ASCEND);

      }
      
      
   return (0);
  }

*/
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++